package xyz.lychee.lagfixer.hooks;

import com.bgsoftware.wildstacker.api.WildStackerAPI;
import com.bgsoftware.wildstacker.api.objects.StackedItem;
import java.util.List;
import org.bukkit.entity.Item;
import org.bukkit.inventory.ItemStack;
import xyz.lychee.lagfixer.LagFixer;
import xyz.lychee.lagfixer.managers.HookManager;
import xyz.lychee.lagfixer.managers.SupportManager;
import xyz.lychee.lagfixer.objects.AbstractHook;
import xyz.lychee.lagfixer.objects.AbstractStacker;

public class WildStackerHook extends AbstractHook {
   private static WildStackerHook instance;

   public WildStackerHook(LagFixer plugin, HookManager manager) {
      super(plugin, manager);
      instance = this;
   }

   public void load() {
      SupportManager.getInstance().setStacker(new StackerImplementation());
   }

   public void disable() {
   }

   public String plugin() {
      return "WildStacker";
   }

   public static WildStackerHook getInstance() {
      return instance;
   }

   public static class StackerImplementation extends AbstractStacker {
      public void addItemsToList(Item bItem, List<ItemStack> items) {
         StackedItem item = WildStackerAPI.getStackedItem(bItem);
         if (item == null) {
            items.add(bItem.getItemStack());
         } else {
            ItemStack is = item.getItemStack();
            int amount = item.getStackAmount();
            int max = is.getMaxStackSize();
            if (amount <= max) {
               ItemStack clone = is.clone();
               clone.setAmount(amount);
               items.add(clone);
            } else {
               for(int i = amount; i > 0; i -= max) {
                  ItemStack clone = is.clone();
                  clone.setAmount(Math.min(i, max));
                  items.add(clone);
               }
            }

         }
      }
   }
}
